#include "testlib.h"

#include <vector>
#include <map>
#include <set>
#include <functional>
#include <fstream>

using namespace std;

inline void hash_combine(std::size_t& seed, int v)
{
    std::hash<int> hasher;
    seed ^= std::hash<int>()(v) + 0x9e3779b9 + (seed<<6) + (seed>>2);
}

bool check_seq(std::vector<int>& v) {
        bool flag = true;

        if (v.size() < 3) {
            return true;
        }

        int badCnt = 0;
        int badIdx = 0;

        for (int j = 0; j < v.size() - 1; ++j) {
             if (v[j + 1] < v[j]) {
                 badCnt++;
                 badIdx = j;
             }
        }
 
        if (badCnt > 1) 
            return false;

        for (int j = std::max<int>(0, badIdx - 4); j < std::min<int>(v.size(), badIdx + 4); ++j) { 
             auto ccur = v;
             flag = true;
             ccur.erase(ccur.begin() + j);
             for (int y = 1; y < v.size() - 1; ++y) {
                 if (ccur[y - 1] >= ccur[y]) {
                     flag = false;
                     break;
                 }
             }
             if (flag == true) { break; } 
        }
        return flag;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    size_t hash = n;
    vector<vector<int>> a(n, vector<int>(n, 0));

    std::map<int, int> s_b;
    std::map<int, int> s_e;

    map<int, int> cnts;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            a[i][j] = inf.readInt();
            hash_combine(hash, a[i][j]);
            cnts[a[i][j]] += 1;
        }
    }

    set<pair<int, int>> neib;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            neib.insert(make_pair(a[i][j], a[i][j + 1]));
            neib.insert(make_pair(a[i][j + 1], a[i][j]));
        }
    }
 
    for (int j = 0; j < n; ++j) {
        for (int i = 0; i < n - 1; ++i) {
            neib.insert(make_pair(a[i][j], a[i + 1][j]));
            neib.insert(make_pair(a[i + 1][j], a[i][j]));
        }
    } 
    int cnt = 0;

    int k = ouf.readInt();

    std::vector<std::vector<int>> all_sequence;

    for (int i = 0; i < k; ++i) {
        int m = ouf.readInt();
        cnt += m;
        vector<int> cur(m);
        for (int j = 0; j < m; ++j) {
             cur[j] = ouf.readInt();
             if (j == 0) {
                 s_b[cur[j]] = i;             
             }
             if (j == m - 1) {
                 s_e[cur[j]] = i;
             }
             cnts[cur[j]] -= 1;
             if (cnts[cur[j]] < 0) {
                 quitf(_wa, "unexisting element %d", cur[j]);
             }
        }
        all_sequence.push_back(cur);
        
        if (!check_seq(cur)) {
             quitf(_wa, "wrong sequence %d", i);
        }

        for (int j = 0; j < m - 1; ++j) {
            if (neib.count(make_pair(cur[j], cur[j+1])) == 0) {
                quitf(_wa, "wrong neib %d %d %d", i, cur[j], cur[j + 1]);    
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            if ((s_b.find(a[i][j]) != s_b.end()) && s_e.find(a[i][j + 1]) != s_e.end()) {
                 auto bb = all_sequence[s_e[a[i][j + 1]]];
                 bb.insert(bb.end(), all_sequence[s_b[a[i][j]]].begin(), all_sequence[s_b[a[i][j]]].end());
                 if (check_seq(bb)) {
                      for (auto e : bb) {
                          std::cout << e <<" ";
                      }
                      quitf(_wa, "may connect1 %d %d", i, j);
                 }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            if ((s_e.find(a[i][j]) != s_e.end()) && s_b.find(a[i][j + 1]) != s_b.end()) {
                 auto bb = all_sequence[s_e[a[i][j]]];
                 bb.insert(bb.end(), all_sequence[s_e[a[i][j + 1]]].begin(), all_sequence[s_e[a[i][j + 1]]].end());
                 if (check_seq(bb)) {
                      quitf(_wa, "may connect2 %d %d", i, j);
                 }
            }
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n; ++j) {
            if ((s_b.find(a[i][j]) != s_b.end()) && s_e.find(a[i + 1][j]) != s_e.end()) {
                 auto bb = all_sequence[s_e[a[i + 1][j]]];
                 bb.insert(bb.end(), all_sequence[s_b[a[i][j]]].begin(), all_sequence[s_b[a[i][j]]].end());
                 if (check_seq(bb)) {
                      quitf(_wa, "may connect3 %d %d", i, j);
                 }
            }
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n; ++j) {
            if ((s_e.find(a[i][j]) != s_e.end()) && s_b.find(a[i + 1][j]) != s_b.end()) {
                 auto bb = all_sequence[s_b[a[i][j]]];
                 bb.insert(bb.end(), all_sequence[s_e[a[i + 1][j]]].begin(), all_sequence[s_e[a[i + 1][j]]].end());
                 if (check_seq(bb)) {
                      quitf(_wa, "may connect4 %d %d", i, j);
                 }
            }
        }
    }



    for (auto [k, v] : cnts) {
        if (v != 0) {
            quitf(_wa, "unvisited element %d %d", k, v);
        }
    }

    std::string path = "/home/judges/000199/problems/pseudofil/log/" + std::to_string(hash) + ".txt"; 

    std::set<double> s;
    double cur;

    std::fstream f(path, fstream::in);
    while (f>>cur) {
        s.insert(cur);
    }
 
    std::cout << path << std::endl;

    if (s.count(1. * cnt / k) == 0) {
         std::cout << "some" << std::endl;
         std::fstream f(path, fstream::in | fstream::out | fstream::app);
         f << 1. * cnt / k << std::endl;
    }


    quitf(_ok, "");
}
